Picker = {
	currentH: 0,
	currentS: 0,
	currentL: .67,
	thumbH: null,
	thumbS: null,
	thumbL: null,
	sliderS: null,
	display: null,

	enterKey: null,
	returnKey: null,
	escapeKey: null,
	homeKey: null,
	endKey: null,
	leftKey: null,
	rightKey: null,

	close: function (ok) {
		if (ok) {
			alert(window.parent);
			}
		window.close();
		},

	init: function () {
		var e = document.getElementById("h-scroll");
		e.setAttribute("curpos", 0);
		var s = document.getAnonymousNodes(e)[2];
		this.thumbH = s.firstChild;

		e = document.getElementById("s-scroll");
		e.setAttribute("curpos", 0);
		s = document.getAnonymousNodes(e)[2];
		this.sliderS = s;
		this.thumbS = s.firstChild;

		e = document.getElementById("l-scroll");
		e.setAttribute("curpos", 0);
		s = document.getAnonymousNodes(e)[2];
		this.thumbL = s.firstChild;

		this.display = document.getElementById("color-result");

		this._update();
		this.thumbH.focus();

		with (Components.interfaces.nsIDOMKeyEvent) {
			enterKey = DOM_VK_ENTER;
			returnKey = DOM_VK_RETURN;
			escapeKey = DOM_VK_ESCAPE;
			homeKey = DOM_VK_HOME;
			endKey = DOM_VK_END;
			leftKey = DOM_VK_LEFT;
			rightKey = DOM_VK_RIGHT;
			}
		},

	// user pressed a key
	key: function (event) {
		switch (event.keyCode) {
			case enterKey:
			case returnKey:
				this.close(true);
				return;
				break;
			case escapeKey:
				this.close(false);
				return;
				break;
			}

		var s = document
			.commandDispatcher
			.focusedElement
			.parentNode
			.parentNode;
		var p = parseInt(s.getAttribute("curpos"));
		switch (event.keyCode) {
			case homeKey:
				p = 0;
				break;
			case endKey:
				p = 100;
				break;
			case leftKey:
				p--;
				break;
			case rightKey:
				p++;
				break;
			default:
				return;
			}
		if (p < 0) p = 0; else if (p > 100) p = 100;
		s.setAttribute("curpos", p);
		switch (s.id) {
			case "h-scroll":
				this.currentH = p / 100;
				break;
			case "s-scroll":
				this.currentS = p / 100;
				break;
			case "l-scroll":
				this.currentL = .67 + p / 300;
				break;
			}

		this._update();
		},

	// user moved a slider
	moveH: function (e) {
		var s = document.getAnonymousNodes(e)[2];
		var t = s.firstChild;
		this.currentH = parseInt(e.getAttribute("curpos")) / 100;
		this._update();
		},

	moveS: function (e) {
		var s = document.getAnonymousNodes(e)[2];
		var t = s.firstChild;
		this.currentS = parseInt(e.getAttribute("curpos")) / 100;
		this._update();
		},

	moveL: function (e) {
		var s = document.getAnonymousNodes(e)[2];
		var t = s.firstChild;
		this.currentL = .67 + parseInt(e.getAttribute("curpos")) / 300;
		this._update();
		},

	// HSL in range 0-1, to RGB string
	_hsltorgb: function (h, s, l) {
		var m2 = (l <= 0.5)? l * (s + 1) : l + s - l * s;
		var m1 = l * 2 - m2;
		return "rgb("
			+ this._huetorgb(m1, m2, h + 1 / 3) + ","
			+ this._huetorgb(m1, m2, h) + ","
			+ this._huetorgb(m1, m2, h - 1 / 3) + ")";
		},

	_huetorgb: function (m1, m2, h) {
		if (h < 0) h = h + 1;
		if (h > 1) h = h - 1;
		var v;
		if (h * 6 < 1) v = m1 + (m2 - m1) * h * 6;
		else if (h * 2 < 1) v = m2;
		else if (h * 3 < 2) v = m1 + (m2 - m1) * (2 / 3 - h) * 6;
		else v = m1;
		return (v == 1)? 255 : Math.floor(256 * v);
		},

	_update: function () {

try {
		var rgb = this._hsltorgb(this.currentH, 1, .5);
		this.thumbH.style.backgroundColor = rgb;
		this.sliderS.style.backgroundColor = rgb;
		rgb = this._hsltorgb(this.currentH, this.currentS, .67 - .17 * this.currentS);
		this.thumbS.style.backgroundColor = rgb;
		rgb = this._hsltorgb(0, 0, this.currentL);
		this.thumbL.style.backgroundColor = rgb;
		rgb = this._hsltorgb(this.currentH, this.currentS, this.currentL);
		this.display.style.backgroundColor = rgb;

} catch (e) {alert(e);}
		}

	}
