Dialog = {
	accept: null,
	cancel: null,
	password: null,
	status: null,
	fail: null,
	thread: null,

	close: function (ok) {
		const jc = window.opener.pass.jcrypt;
		if (ok) {
			var p = document.getElementById("password").value;
			if (jc.validate(p, 1)) {
				jc.passkey = jc.sha1(p + "k", 1)
				jc.key = jc.getKey(jc.hash(2), jc.passkey);
				jc.fail = 0;
				return true;
				}
			else {
				jc.key = null;
				jc.passkey = null;
				jc.fail++;
				window.setCursor("wait");
				this.thread.sleep(1000 * Math.pow(1.75, jc.fail));
				window.setCursor("default");
				this._reset();
				return false;
				}
			}
		else return true;
		},

	init: function () {
		document.getElementById("name").value = window.opener.pass.user;

		this.status = document.getElementById("status");
		this.password = document.getElementById("password");

		var dlg = document.documentElement;
		this.accept = dlg.getButton("accept");
		this.cancel = dlg.getButton("cancel");

		this.thread = Components
			.classes["@mozilla.org/thread;1"]
			.createInstance(Components.interfaces.nsIThread)
			.currentThread;

		this._reset();
		},

	input: function () {
		var ok = (this.password.value != "");
		with (this.accept) {
			disabled = !ok;
			if (ok) setAttribute("default", "true"); else removeAttribute("default");
			}
		with (this.cancel) {
			if (!ok) setAttribute("default", "true"); else removeAttribute("default");
			}		
		},

	_reset: function () {
		this.password.value = "";
		this.input();

		var f = window.opener.pass.jcrypt.fail;
		this.status.value =
			(f == 0)? "" :
			(f == 1)? this.status.getAttribute("oneFail") :
			this.status.getAttribute("moreFail").replace(/%/, f);

		this.password.focus();
		}
	}
