Deck = {
	deck: null,

	init: function () {
		this.deck = document.getElementById("content");
		},

	page: function (n) {
		try {
			with (this.deck) {
				selectedIndex = n;
				var h = selectedPanel.getAttribute("home");
				document.getElementById(h).focus();
				}
			}
		catch (e) {alert("Deck.page\n" + e);}
		}

	}



Dialog = {
	isDirty: false,

	changed: function () {
		if (!this.isDirty) {
			with (document.getElementById("cancel-button")) {
				removeAttribute("default");
				}
			with (document.getElementById("ok-button")) {
				disabled = false;
				setAttribute("default", "true");
				}
			this.isDirty = true;
			}
		},

	close: function (ok) {
		try {
			if (ok) {
				ok = this._pwcheck();
				if (!ok) return false;
				Pref.save();
				}
			window.close();
			}
		catch (e) {alert("Dialog.close " + e);}
		},

	// user typed current password
	gotPass: function () {
		var ok = (document.getElementById("password0-text").value != "");
		document.getElementById("recover-button").disabled = ok;
		document.getElementById("password1-text").disabled = !ok;
		document.getElementById("password2-text").disabled = !ok;
		document.getElementById("question-text").disabled = !ok;
		document.getElementById("answer-text").disabled = !ok;
		},

	init: function () {
		try {
			Deck.init();
			document.getElementById("journal-menu").datasources = window.opener.pass.journals.URI;
			Pref.load();
			}
		catch (e) {alert("Dialog.init " + e);}
		},

	recover: function () {
		var p = Components
			.classes["@mozilla.org/embedcomp/prompt-service;1"]
			.getService(Components.interfaces.nsIPromptService);
		var r = {value: null};
		var ok = p.promptPassword(
				self,
				"Recover Password",
				"What's my name?",
				r,
				null,
				{});
		if (!ok) return;

		if (r.value == "Fred") {
			with (document.getElementById("password0-text")) {
				value = "recovered";
				disabled = true;
				}
			this.gotPass();
			document.getElementById("password1-text").focus();
			}
		else {
			p.alert(self, "Recover Password", "Recovery failed");
			}
		},

	// password checks
	_pwcheck: function () {
		var p1 = document.getElementById("password1-text").value;
		if (p1 == "") return true;

		var p2 = document.getElementById("password2-text").value;
		if (p1 != p2) {
			this._pwalert("errmatch");
			return false;
			}

		var jc = opener.pass.jcrypt;
		if (jc.hasHash(1)) {
			var p0 = document.getElementById("password0-text").value;
			if (p0 == "") {
				this._pwalert("errnopw");
				return false;
				}
			if (!jc.validate(p0, 1)) {
				jc.fail++;
				window.setCursor("wait");
				Components
					.classes["@mozilla.org/thread;1"]
					.createInstance(Components.interfaces.nsIThread)
					.currentThread
					.sleep(1000 * Math.pow(1.75, jc.fail));
				window.setCursor("default");
				this._pwalert("errbadpw");
				return false;
				}
			}

		jc.createHash(p1, null, 1);
		jc.login.removeAttribute("disabled");

		if (!jc.hasHash(2)) {
			var o = document.getElementById("owner-text").value;
			jc.key = jc.sha1(o + Date().toString(), null);
			jc.createHash(jc.key, p1, 2);
			}

		return true;
		},

	_pwalert: function (e) {
		const g = document.getElementById("password-group");
		Components
			.classes["@mozilla.org/embedcomp/prompt-service;1"]
			.getService(Components.interfaces.nsIPromptService)
			.alert(
				self,
				g.getAttribute("errtitle"),
				g.getAttribute(e));
		}

	}


Pref = {
	branch: Components
		.classes['@mozilla.org/preferences-service;1']
		.getService(Components.interfaces.nsIPrefService)
		.getBranch("journal."),

	field: function (id) {
		return document.getElementById(id);
		},

	load: function () {
		this.field("sidebar-check").value = this.value("startup.sidebar", "");
		this.field("calendar-check").value = this.value("startup.calendar", "");

		v = this.value("startup.view", "");
		this.field("view-check").checked = (v != "");
		var f = this.field("view-menu");
		if (v != "") f.removeAttribute("disabled");
		f.value = v;
		if (v == "") f.selectedItem = null;

		v = this.value("startup.journal", "");
		this.field("journal-check").checked = (v != "");
		f = this.field("journal-menu");
		if (v != "") f.removeAttribute("disabled");
		f.value = v;
		if (v == "") f.selectedItem = null;

		v = this.value("startup.content", "");
		this.field("content-check").checked = (v != "");
		f = this.field("content-menu");
		if (v != "") f.removeAttribute("disabled");
		f.value = v;
		if (v == "") f.selectedItem = null;

		this.field("login-check").value = this.value("startup.login", "");

		this.field("owner-text").value = this.value("username", "Anonymous");
		this.field("question-text").value = this.value("password.question", "");

		var pw = (opener.pass.jcrypt.hasHash(1));
		with (this.field("password0-text")) {
			value = "";
			disabled = !pw;
			}
		this.field("recover-button").disabled = !pw
		this.field("password1-text").disabled = pw;
		this.field("password2-text").disabled = pw;
		this.field("question-text").disabled = pw;
		this.field("answer-text").disabled = pw;

		v = this.value("timeout.clear", 0);
		this.field("clear-check").checked = (v != 0);
		this.field("clear-text").value = (v == 0)? "" : v;

		v = this.value("timeout.logout", 0);
		this.field("logout-check").checked = (v != 0);
		this.field("logout-text").value = (v == 0)? "" : v;

		},

	save: function () {
		this.set("startup.sidebar", this.field("sidebar-check").value);
		this.set("startup.calendar", this.field("calendar-check").value);

		this.set(
			"startup.view",
			(this.field("view-check").checked)? this.field("view-menu").value : "");
		this.set(
			"startup.journal",
			(this.field("journal-check").checked)? this.field("journal-menu").value : "");
		this.set(
			"startup.content",
			(this.field("content-check").checked)? this.field("content-menu").value : "");

		this.set("startup.login", this.field("login-check").value);

		var v = this.field("clear-text").value;
		this.set("timeout.clear", (v == "")? 0 : parseInt(v));

		v = this.field("logout-text").value;
		this.set("timeout.logout", (v == "")? 0 : parseInt(v));
		},

	set: function (name, val) {
		try {
			if (String(val).search(/^\d/) == 0)
				this.branch.setIntPref(name, val);
			else if (val === true || val === false)
				this.branch.setBoolPref(name, val);
			else
				this.branch.setCharPref(name, val);
			}
		catch (e) {alert("Pref.set " + name + " ='" + val + "'\n" + e);}
		},

	value: function (name, dflt) {
		var t = null;
		try {t = this.branch.getPrefType(name);} catch (e) {}
		if (!t) return dflt;
		try {
			switch (t) {
				case 0:
					return dflt;
					break;
				case 32:
					return this.branch.getCharPref(name);
					break;
				case 64:
					return this.branch.getIntPref(name);
					break;
				case 128:
					return this.branch.getBoolPref(name);
					break;
				}
			}
		catch (e) {return dflt;}
		}

	}


UI = {
	clear: function (a) {	// element array
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				var v;
				switch (e.localName) {
					case "radiogroup":
					case "menulist":
						v = e.selectedIndex;
						if (v < 0) v = null;
						e.selectedItem = null;
						break;
					case "textbox":
						v = e.value;
						e.value = "";
						break;
					case "checkbox":
						v = e.checked;
						e.checked = false;
						break;
					}
				if (v != null && !e.hasAttribute("was")) e.setAttribute("was", v);
				}
			}
		catch (e) {alert("UI.clear\n" + e);}
		},

	disable: function (a) {	// element array
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				switch (e.localName) {
					case "menuitem":
						var m = e.parentNode.parentNode;
						var s = m.selectedItem;
						if (s == e) m.selectedItem = null;
						break;
					}
				e.disabled = true;
				}
			}
		catch (e) {alert("UI.disable\n" + e);}
		},

	enable: function (a, s) {	// element array, setting
		try {
			var d = (s == undefined)? false : !s;
			for (var i = 0; i < a.length; ++i) {
				document.getElementById(a[i]).disabled = d;
				}
			}
		catch (e) {alert("UI.enable\n" + e);}
		},

	ensure: function (a, d) {	// element array, default value
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				switch (e.localName) {
					case "menulist":
						if (!e.hasAttribute("disabled") && e.selectedIndex < 0) e.selectedIndex = d;
						break;
					case "checkbox":
						if (e.checked != d) e.checked = d;
						break;
					}
				}
			}
		catch (e) {alert("UI.ensure\n" + e);}
		},

	focus: function (i) { // element id
		with (document.getElementById(i)) {
			focus();
			if (localName == "textbox") select();
			}
		},

	logic: function (a) {	// element array
		try {
			for (var i = 0; i < a.length; ++i) {
				with (document.getElementById(a[i])) {
					if (!hasAttribute("disabled")) logic();
					}
				}
			}
		catch (e) {alert("UI.logic " + a[i] + "\n" + e);}
		},

	restore: function (a, d) {	// element array, default
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				var v = (e.hasAttribute("was"))? e.getAttribute("was") : d;
				switch (e.localName) {
					case "radiogroup":
					case "menulist":
						if (v != null) e.selectedIndex = v;
						break;
					case "textbox":
						if (v != null) e.value = v;
						break;
					case "checkbox":
						if (v != null) e.checked = (v == "true");
						break;
					}
				e.removeAttribute("was");
				}
			}
		catch (e) {alert("UI.restore\n" + e);}
		}
	}
