Categories = {
	listbox: null,
	schedlist: null,

	init: function () {
		try {
			this.listbox = document.getElementById("category-list");
			this.listbox.datasources = Journal.ds.URI;
			}
		catch (e) {alert("Categories.init\n" + e);}
		},

	select: function () {
		Category.init(this.listbox.selectedItem.id);
		}

	}


Category = {

	add: function () {
		alert("Category.add");
		},

	clear: function () {
		with (document.getElementById("category-text")) {
			value = "";
			focus();
			}
		document.getElementById("scheduled-check").checked = false;
		document.getElementById("secure-check").checked = false;
		document.getElementById("draft-check").checked = false;
		},

	init: function (id) {
		try {
			var r = RDF.GetResource(id);
			var c = Journal.ds.GetTarget(r, RDF.GetResource(Journal.jns + "name"),true);
			var v = c.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			document.getElementById("category-text").value = v;

			c = Journal.ds.GetTarget(r, RDF.GetResource(Journal.jns + "class"),true);
			v = c.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			document.getElementById("scheduled-check").checked = (v.search(/scheduled/) >= 0);
			document.getElementById("secure-check").checked = (v.search(/private/) >= 0);
			document.getElementById("draft-check").checked = (v.search(/draft/) == -1);
			}
		catch (e) {alert("Category.init\n" + e);}
		},

	remove: function () {
		alert("Category.delete");
		}

	}


Dialog = {
	deck: null,
	topCheck: null,
	bottomCheck: null,
	leftCheck: null,
	rightCheck: null,
	centerCheck: null,

	isDirty: false,
	working: false,

	changed: function () {
		if (this.working) return;

		var t = document
			.getElementById("title-text")
			.value
			.replace(/^\s+/, "")
			.replace(/\s+$/, "");
		var ok = (t != "" && this.isDirty);

		with (document.getElementById("cancel-button")) {
			if (ok) removeAttribute("default");
			else setAttribute("default", "true");
			}
		with (document.getElementById("ok-button")) {
			disabled = !ok;
			if (ok) setAttribute("default", "true");
			else removeAttribute("default");
			}
		this.isDirty = true;
		},

	close: function (ok) {
		try {
			if (ok) {
				this._save();
				var dr = RDF.GetResource("urn:dialog");
				var dp = RDF.GetResource("urn:dialog:ok");
				var dt = RDF.GetLiteral("true");
				Journal.ds.Assert(dr, dp, dt, true);
				}
			}
		catch (e) {alert("Dialog.close\n" + e);}
		window.opener.pass = null;
		window.close();
		},

	// initialize
	init: function () {
		topCheck = document.getElementById("top-position");
		bottomCheck = document.getElementById("bottom-position");
		leftCheck = document.getElementById("left-position");
		rightCheck = document.getElementById("right-position");
		centerCheck = document.getElementById("center-position");
		this._load();
		},

	// position checkbox logic...
	position: function (e) {
		switch (e.id) {
			case "top-position":
				if (e.checked) bottomCheck.checked = false;
				if (leftCheck.checked || rightCheck.checked) centerCheck.checked = false;
				break;
			case "bottom-position":
				if (e.checked) topCheck.checked = false;
				if (leftCheck.checked || rightCheck.checked) centerCheck.checked = false;
				break;
			case "left-position":
				if (e.checked) rightCheck.checked = false;
				if (topCheck.checked || bottomCheck.checked) centerCheck.checked = false;
				break;
			case "right-position":
				if (e.checked) leftCheck.checked = false;
				if (topCheck.checked || bottomCheck.checked) centerCheck.checked = false;
				break;
			case "center-position":
				if (e.checked) {
					var c = topCheck;
					var c1 = false;
					while (c != centerCheck) {
						if (c1) c.checked = false;
						else c1 = c.checked;
						c = c.nextSibling;
						}
					}
				break;
			}
		if (!topCheck.checked
			&& !bottomCheck.checked
			&& !leftCheck.checked
			&& !rightCheck.checked) {
			if (e.id == "center-position") {
				topCheck.checked = true;
				leftCheck.checked = true;
				}
			else {
				centerCheck.checked = true;
				}
			}
		},

	// user selected a tab
	tab: function (event) {
		if (document
			.getElementById("properties-tabs")
			.selectedItem
			.id == "schedule-tab")
			Schedule.init();
		},

	_load: function () {
		this.working = true;
		Journal.init(window.arguments[0]);
		document.getElementById("author-text").value = Journal.getProperty("author", "");
		document.getElementById("title-text").value = Journal.getProperty("name", "");
		document.getElementById("description-text").value = Journal.getProperty("description", "");

		var c = Journal.getProperty("class", "");
		document.getElementById("readonly-check").checked = (c.search(/final/) >= 0);

		document.getElementById("font-lang-menulist").value = Journal.getProperty("fontlang", "x-western");
		document.getElementById("font-type-menulist").value = Journal.getProperty("fonttype", "serif");
		Fonts.fill();
		document.getElementById("font-face-menulist").value = Journal.getProperty("fontface", "");
		document.getElementById("font-size-textbox").value = Journal.getProperty("fontsize", "10");

		var ch = 0, cs = 0, cl = 0;
		try {
			c = Journal
				.getProperty("paper", "rgb(255,255,238);17,100,97")
				.match(/;(\d+),(\d+),(\d+)/);
			ch = c[1];
			cs = c[2];
			cl = c[3];
			if (cl < 67) cl = 67;
			}
		catch (e) {alert("Dialog.load hsl\n" + e);}

		var h1 = Journal.getProperty("hash1", "");
		c = (h1 != "");
		document.getElementById("private-check").checked = c;
		if (c) {
			c = atob(h1);
			with (document.getElementById("encrypt-radiogroup")) {
				selectedIndex = c.charCodeAt(c.length - 1) & 3;
				selectedItem.disabled = false;
				}
			}

		if (opener.pass.isnew && opener.pass.jcrypt.key) {
			document.getElementById("private-check").disabled = false;
			document.getElementById("encrypt-none").disabled = false;
			document.getElementById("encrypt-weak").disabled = false;
			document.getElementById("encrypt-medium").disabled = false;
			}

		Picker.init(ch, cs, cl);
		Categories.init();

		this.working = false;
		},

	_save: function () {
		var jc = opener.pass.jcrypt;

		this._prop("author", "author-text");

		var n0 = Journal.getProperty("name", "");
		this._prop("name", "title-text");
		if (n0 != Journal.getProperty("name", ""))
			Journal.setProperty("hash0", jc.sha1(
				Journal.getProperty("name") + Journal.getProperty("author"))); 

		this._prop("description", "description-text");
		this._prop("paper", "color-result");
		this._prop("fontlang", "font-lang-menulist");
		this._prop("fonttype", "font-type-menulist");
		this._prop("fontface", "font-face-menulist");
		this._prop("fontsize", "font-size-textbox");

		if (opener.pass.isnew && jc.key && document.getElementById("private-check").checked) {
			var g = ((0xFFFFFFF * Math.random()) << 2) | document.getElementById("encrypt-radiogroup").value;
			Journal.setProperty("hash1", jc.sha1(jc.key + Date().toString(), g));
			}

		var c = (document.getElementById("readonly-check").checked)? "final" : "";
		Journal.setProperty("class", c);	
		},

	_prop: function (p, e) {
		var t = document.getElementById(e);
		var v = t.value;
		if (v == undefined) v = t.getAttribute("value");
		if (p == "name") v = v.replace(/^\s+/, "").replace(/\s+$/, "").replace(/\s\s/g, " ");
		Journal.setProperty(p, v);
		}

	}


Fonts = {
	fill: function () {
		var popup = document.getElementById("font-face-popup");
		var l = document.getElementById("font-lang-menulist").value;
		var t = document.getElementById("font-type-menulist").value;
		var n = {value:0};
		var f = Components
			.classes["@mozilla.org/gfx/fontenumerator;1"]
			.createInstance(Components.interfaces.nsIFontEnumerator)
			.EnumerateFonts(l, t, n);
		var c;
		popup.parentNode.selectedItem = null;
		while (c = popup.firstChild) popup.removeChild(c);
		popup.parentNode.disabled = (n.value == 0);
		for (var i = 0; i < n.value; ++i) {
			c = document.createElement("menuitem");
			c.setAttribute("label", f[i]);
			c.setAttribute("value", f[i]);
			popup.appendChild(c);
			}
		}
	
	}


Journal = {
	ds: null,
	jns: "http://journal.mozdev.org/ns#",
	root: null,

	init: function (ads) {
		this.ds = ads.QueryInterface(Components.interfaces.nsIRDFDataSource);
		this.root = RDF.GetResource("urn:journal");
		},

	// property from name, default value
	getProperty: function (p, d) {
		try {
			var r = this.ds
				.GetTarget(this.root, RDF.GetResource(this.jns + p), true);
			if (!r) return d;
			return r
				.QueryInterface(Components.interfaces.nsIRDFLiteral)
				.Value;
			}
		catch (e) {alert("Journal.getProperty " + p + "\n" + e);}
		},

	// property name, value
	setProperty: function (p, v) {
		try {
			var res = RDF.GetResource(this.jns + p);
			var r = this.ds.GetTarget(this.root, res, true);
			if (r && r.QueryInterface(Components.interfaces.nsIRDFLiteral).Value == v) return;
			if (r) this.ds.Unassert(this.root, res, r, true);
			this.ds.Assert(this.root, res, RDF.GetLiteral(v), true);
			}
		catch (e) {alert("Journal.setProperty " + p + " = " + v + "\n" + e);}
		}

	}


Picker = {
	currentH: 0,
	currentS: 0,
	currentL: .67,
	thumbH: null,
	thumbS: null,
	thumbL: null,
	sliderS: null,
	display: null,

	enterKey: null,
	returnKey: null,
	escapeKey: null,
	homeKey: null,
	endKey: null,
	leftKey: null,
	rightKey: null,

	close: function (ok) {
		if (ok) {
			alert(window.parent);
			}
		window.close();
		},

	init: function (ch, cs, cl) {
		this.currentH = ch / 100;
		this.currentS = cs / 100;
		this.currentL = cl / 100;

		var e = document.getElementById("h-scroll");
		e.setAttribute("curpos", ch);
		var s = document.getAnonymousNodes(e)[2];
		this.thumbH = s.firstChild;

		e = document.getElementById("s-scroll");
		e.setAttribute("curpos", cs);
		s = document.getAnonymousNodes(e)[2];
		this.sliderS = s;
		this.thumbS = s.firstChild;

		e = document.getElementById("l-scroll");
		e.setAttribute("curpos", 3 * (cl - 67));
		s = document.getAnonymousNodes(e)[2];
		this.thumbL = s.firstChild;

		this.display = document.getElementById("color-result");

		this._update();

		with (Components.interfaces.nsIDOMKeyEvent) {
			enterKey = DOM_VK_ENTER;
			returnKey = DOM_VK_RETURN;
			escapeKey = DOM_VK_ESCAPE;
			homeKey = DOM_VK_HOME;
			endKey = DOM_VK_END;
			leftKey = DOM_VK_LEFT;
			rightKey = DOM_VK_RIGHT;
			}
		},

	// user pressed a key
	key: function (event) {
		switch (event.keyCode) {
			case enterKey:
			case returnKey:
				this.close(true);
				return;
				break;
			case escapeKey:
				this.close(false);
				return;
				break;
			}

		var s = document
			.commandDispatcher
			.focusedElement
			.parentNode
			.parentNode;
		var p = parseInt(s.getAttribute("curpos"));
		switch (event.keyCode) {
			case homeKey:
				p = 0;
				break;
			case endKey:
				p = 100;
				break;
			case leftKey:
				p--;
				break;
			case rightKey:
				p++;
				break;
			default:
				return;
			}
		if (p < 0) p = 0; else if (p > 100) p = 100;
		s.setAttribute("curpos", p);
		switch (s.id) {
			case "h-scroll":
				this.currentH = p / 100;
				break;
			case "s-scroll":
				this.currentS = p / 100;
				break;
			case "l-scroll":
				this.currentL = .67 + p / 300;
				break;
			}

		this._update();
		},

	// user moved a slider
	moveH: function (e) {
		var s = document.getAnonymousNodes(e)[2];
		var t = s.firstChild;
		this.currentH = parseInt(e.getAttribute("curpos")) / 100;
		this._update();
		},

	moveS: function (e) {
		var s = document.getAnonymousNodes(e)[2];
		var t = s.firstChild;
		this.currentS = parseInt(e.getAttribute("curpos")) / 100;
		this._update();
		},

	moveL: function (e) {
		var s = document.getAnonymousNodes(e)[2];
		var t = s.firstChild;
		this.currentL = .67 + parseInt(e.getAttribute("curpos")) / 300;
		this._update();
		},

	// HSL in range 0-1, to RGB string
	_hsltorgb: function (h, s, l) {
		var m2 = (l <= 0.5)? l * (s + 1) : l + s - l * s;
		var m1 = l * 2 - m2;
		return "rgb("
			+ this._huetorgb(m1, m2, h + 1 / 3) + ","
			+ this._huetorgb(m1, m2, h) + ","
			+ this._huetorgb(m1, m2, h - 1 / 3) + ")";
		},

	_huetorgb: function (m1, m2, h) {
		if (h < 0) h = h + 1;
		if (h > 1) h = h - 1;
		var v;
		if (h * 6 < 1) v = m1 + (m2 - m1) * h * 6;
		else if (h * 2 < 1) v = m2;
		else if (h * 3 < 2) v = m1 + (m2 - m1) * (2 / 3 - h) * 6;
		else v = m1;
		return (v == 1)? 255 : Math.floor(256 * v);
		},

	_rgbtohsl: function (r, g, b) {
		// is this needed?
		},

	_update: function () {
		var rgb = this._hsltorgb(this.currentH, 1, .5);
		this.thumbH.style.backgroundColor = rgb;
		this.sliderS.style.backgroundColor = rgb;
		rgb = this._hsltorgb(this.currentH, this.currentS, .67 - .17 * this.currentS);
		this.thumbS.style.backgroundColor = rgb;
		rgb = this._hsltorgb(0, 0, this.currentL);
		this.thumbL.style.backgroundColor = rgb;
		rgb = this._hsltorgb(this.currentH, this.currentS, this.currentL);
		this.display.style.backgroundColor = rgb;
		var hsl = Math.floor(this.currentH * 100)	+ ","
			+ Math.floor(this.currentS * 100) + ","
			+ Math.floor(this.currentL * 100);
		this.display.setAttribute("value", rgb + ";" + hsl);
		Dialog.changed();
		}

	}


RCU = Components
	.classes['@mozilla.org/rdf/container-utils;1']
	.getService(Components.interfaces.nsIRDFContainerUtils);


RDF = Components
	.classes['@mozilla.org/rdf/rdf-service;1']
	.getService(Components.interfaces.nsIRDFService);


Schedule = {
	list: null,

	init: function () {
		try {
			this.list = document.getElementById("schedule-list");
			var b = Categories.listbox;
			var n = b.getRowCount();
			var e, r, c, v, s;
			for (var i = 0; i < n; ++i) {
				e = b.getItemAtIndex(i);
				r = RDF.GetResource(e.id);
				c = Journal.ds.GetTarget(r, RDF.GetResource(Journal.jns + "class"), true);
				v = c.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
				s = (v.search(/scheduled/) >= 0);
				if (s) this.list.appendItem(e.label, e.id);
				}
			this.list.selectedIndex = 0;
			e = this.list.selectedItem;
			var ok = (e != null);
			this.list.disabled = !ok;

			r = RDF.GetResource(e.getAttribute("value"));
			c = Journal.ds.GetTarget(r, RDF.GetResource(Journal.jns + "months"), true);
			v = c.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			var g = document.getElementById("months-checkgroup");
			g.setValues(v);
			var k = !g.allChecked();
			var ak = k;
			UI.ensure(["months-check"], k);
			UI.logic(["months-check"]);

			c = Journal.ds.GetTarget(r, RDF.GetResource(Journal.jns + "weeks"), true);
			v = c.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			var g = document.getElementById("weeks-checkgroup");
			g.setValues(v);
			k = !g.allChecked();
			ak = ak || k;
			UI.ensure(["weeks-check"], k);
			UI.logic(["weeks-check"]);

			c = Journal.ds.GetTarget(r, RDF.GetResource(Journal.jns + "days"), true);
			v = c.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			var g = document.getElementById("days-checkgroup");
			g.setValues(v);
			k = !g.allChecked();
			ak = ak || k;
			UI.ensure(["weekdays-check"], k);
			UI.logic(["weekdays-check"]);

			c = Journal.ds.GetTarget(r, RDF.GetResource(Journal.jns + "dates"), true);
			v = c.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
			v = v.replace(/\s/g, "");;
			var g = document.getElementById("daylist-text");
			g.value = v;
			k = (v.length > 0);
			ak = ak || k;
			UI.ensure(["dates-check"], k);
			UI.logic(["dates-check"]);

			document.getElementById("every-radiogroup").selectedIndex = (ak)? 1 : 0;
			}
		catch (e) {alert("Schedule.init\n" + e);}
		}

	}


// duplicated in pref.js :-(
UI = {
	clear: function (a) {	// element array
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				var v;
				switch (e.localName) {
					case "radiogroup":
					case "menulist":
						v = e.selectedIndex;
						if (v < 0) v = null;
						e.selectedItem = null;
						break;
					case "textbox":
						v = e.value;
						e.value = "";
						break;
					case "checkbox":
						v = e.checked;
						e.checked = false;
						break;
					}
				if (v != null && !e.hasAttribute("was")) e.setAttribute("was", v);
				}
			}
		catch (e) {alert("UI.clear\n" + e);}
		},

	disable: function (a) {	// element array
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				switch (e.localName) {
					case "menuitem":
						var m = e.parentNode.parentNode;
						var s = m.selectedItem;
						if (s == e) m.selectedItem = null;
						break;
					}
				e.disabled = true;
				}
			}
		catch (e) {alert("UI.disable\n" + e);}
		},

	enable: function (a, s) {	// element array, setting
		try {
			var d = (s == undefined)? false : !s;
			for (var i = 0; i < a.length; ++i) {
				document.getElementById(a[i]).disabled = d;
				}
			}
		catch (e) {alert("UI.enable\n" + e);}
		},

	ensure: function (a, d) {	// element array, default value
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				switch (e.localName) {
					case "menulist":
						if (!e.hasAttribute("disabled") && e.selectedIndex < 0) e.selectedIndex = d;
						break;
					case "checkbox":
						if (e.checked != d) e.checked = d;
						break;
					}
				}
			}
		catch (e) {alert("UI.ensure\n" + e);}
		},

	focus: function (i) { // element id
		with (document.getElementById(i)) {
			focus();
			if (localName == "textbox") select();
			}
		},

	logic: function (a) {	// element array
		try {
			for (var i = 0; i < a.length; ++i) {
				with (document.getElementById(a[i])) {
					if (!hasAttribute("disabled")) logic();
					}
				}
			}
		catch (e) {alert("UI.logic " + a[i] + "\n" + e);}
		},

	restore: function (a, d) {	// element array, default
		try {
			for (var i = 0; i < a.length; ++i) {
				var e = document.getElementById(a[i]);
				var v = (e.hasAttribute("was"))? e.getAttribute("was") : d;
				switch (e.localName) {
					case "radiogroup":
					case "menulist":
						if (v != null) e.selectedIndex = v;
						break;
					case "textbox":
						if (v != null) e.value = v;
						break;
					case "checkbox":
						if (v != null) e.checked = (v == "true");
						break;
					}
				e.removeAttribute("was");
				}
			}
		catch (e) {alert("UI.restore\n" + e);}
		}
	}
